/**
 * gclc:fr.bigeon.gclc.proc.TaskPoolTest.java
 * Created on: Aug 19, 2017
 */
package fr.bigeon.gclc.proc;

import static org.junit.Assert.assertEquals;
import static org.junit.Assert.assertNotNull;
import static org.junit.Assert.fail;

import org.junit.Test;

/**
 * <p>
 * TODO
 *
 * @author Emmanuel Bigeon */
public class TaskPoolTest {

    /** Test method for
     * {@link fr.bigeon.gclc.proc.TaskPool#add(fr.bigeon.gclc.proc.Task)}. */
    @Test
    public final void testAdd() {
        TaskPool pool = new TaskPool();
        Task task = null;
        try {
            pool.add(task);
            fail("Expected a null pointer exception");
        } catch (NullPointerException e) {
            assertNotNull(e);
        }
        task = new Task() {
            private final Object lock = new Object();
            private boolean running;
            private InterruptionListener listener;

            @Override
            public void run() {
                synchronized (lock) {
                    while (running) {
                        try {
                            lock.wait(100);
                        } catch (InterruptedException e) {
                            // TODO Auto-generated catch block
                            e.printStackTrace();
                        }
                    }
                }
                listener.interrupted();
            }

            @Override
            public void setRunning(boolean running) {
                synchronized (lock) {
                    this.running = running;
                }
                //
            }

            @Override
            public void rmInterruptionListener(InterruptionListener listener) {
                //
            }

            @Override
            public boolean isRunning() {
                return running;
            }

            @Override
            public String getName() {
                return "Test";
            }

            @Override
            public void addInterruptionListener(InterruptionListener listener) {
                this.listener = listener;
            }
        };
        pool.add(task);
        assertEquals(1, pool.getPIDs().size());

        for (String pid : pool.getPIDs()) {
            assertEquals(task, pool.get(pid));
        }
        Thread th = new Thread(task);
        th.start();
        task.setRunning(false);
        try {
            th.join(1000);
        } catch (InterruptedException e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }

        assertEquals(0, pool.getPIDs().size());
    }
}
